package com.darcy.flutterUUID.flutter_gm_uuid

import android.content.Context
import java.net.NetworkInterface
import java.net.SocketException

/**
 * Author: Shay-Patrick-Cormac
 * Email: fang47881@126.com
 * Ltd: 金螳螂企业（集团）有限公司
 * Date: 2020/6/15 15:43
 * Version: 1.0
 * Description: 类说明
 */
/**
 * 获取设备MAC 地址 由于 6.0 以后 WifiManager 得到的 MacAddress得到都是 相同的没有意义的内容
 * 所以采用以下方法获取Mac地址
 *
 * @param context
 * @return
 */
fun getLocalMac(): String? {
    //        WifiManager wifi = (WifiManager) context
    //                .getSystemService(Context.WIFI_SERVICE);
    //        WifiInfo info = wifi.getConnectionInfo();
    //        return info.getMacAddress();
    val macAddress: String
    val buf = StringBuilder()
    var networkInterface: NetworkInterface?
    try {
        networkInterface = NetworkInterface.getByName("eth1")
        if (networkInterface == null) {
            networkInterface = NetworkInterface.getByName("wlan0")
        }
        if (networkInterface == null) {
            return ""
        }
        val addr = networkInterface.hardwareAddress
        for (b in addr) {
            buf.append(String.format("%02X:", b))
        }
        if (buf.isNotEmpty()) {
            buf.deleteCharAt(buf.length - 1)
        }
        macAddress = buf.toString()
    } catch (e: SocketException) {
        e.printStackTrace()
        return ""
    }
    return macAddress
}
