import Flutter
import UIKit

public class SwiftFlutterGmUuidPlugin: NSObject, FlutterPlugin {
  public static func register(with registrar: FlutterPluginRegistrar) {
    let channel = FlutterMethodChannel(name: "UUID_channel", binaryMessenger: registrar.messenger())
    let instance = SwiftFlutterGmUuidPlugin()
    
    
    
    registrar.addMethodCallDelegate(instance, channel: channel)
    
    
    
    
  }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    
    let method = call.method
    
    if method == "getUuid" {
        result(self.getUUID())
    }
  }
    
    
    
   private func getUUID() -> String {
        var query = self.query()
        var UUID = ""
        
        query[kSecMatchLimit as String] = kSecMatchLimitOne
        query[kSecReturnAttributes as String] = kCFBooleanTrue
        query[kSecReturnData as String] = kCFBooleanTrue
        
        var quertResult: AnyObject?
        
        let state = withUnsafeMutablePointer(to: &quertResult) {
            
           SecItemCopyMatching(query as CFDictionary, UnsafeMutablePointer($0))
        }
        
        if  state == errSecSuccess,
            let existResult = quertResult as? Dictionary<String,AnyObject>,
            let passWordData = existResult[kSecValueData as String] as? Data,
            let passWord = String(data: passWordData, encoding: .utf8) {
               UUID = passWord
        }else {
            
            UUID = UIDevice.current.identifierForVendor?.uuidString ?? ""
            
            
            query[kSecValueData as String] = UUID.data(using: .utf8)
            SecItemAdd(query as CFDictionary, nil)
        }
        
        return UUID
        

    }
    
    
   private func query() -> Dictionary<String, Any> {

        var query = Dictionary<String,Any>()
        query[kSecClass as String] = kSecClassGenericPassword
        query[kSecAttrService as String] = Bundle.main.bundleIdentifier as AnyObject?
        query[kSecAttrAccount as String] = "FlutterUUID"

        return query
    }
}



